"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactiveJs = require("@pksilen/reactive-js");

var _react = require("react");

var _store = require("svelte/store");

var _svelte = require("svelte");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Store =
/*#__PURE__*/
function () {
  function Store(initialState, selectors) {
    var _this = this;

    _classCallCheck(this, Store);

    _defineProperty(this, "reactiveState", void 0);

    _defineProperty(this, "reactiveSelectors", void 0);

    _defineProperty(this, "stateStopWatches", new Map());

    _defineProperty(this, "selectorStopWatches", new Map());

    _defineProperty(this, "viewToNeedsUpdateMap", new Map());

    _defineProperty(this, "componentInstanceToUpdatesMap", new Map());

    _defineProperty(this, "stateWritables", new Map());

    _defineProperty(this, "selectorWritables", new Map());

    _defineProperty(this, "idToUpdatesMap", new Map());

    this.reactiveState = (0, _reactiveJs.reactive)(initialState);
    this.reactiveSelectors = {};

    if (selectors) {
      Object.keys(selectors).forEach(function (key) {
        return _this.reactiveSelectors[key] = (0, _reactiveJs.computed)(function () {
          return (// eslint-disable-next-line @typescript-eslint/ban-ts-ignore
            // @ts-ignore
            selectors[key](_this.reactiveState)
          );
        });
      });
    }
  }

  _createClass(Store, [{
    key: "getState",
    value: function getState() {
      return this.reactiveState;
    }
  }, {
    key: "getSelectors",
    value: function getSelectors() {
      return this.reactiveSelectors;
    }
  }, {
    key: "getStateAndSelectors",
    value: function getStateAndSelectors() {
      return [this.reactiveState, this.reactiveSelectors];
    }
  }, {
    key: "useStateAndSelectorsReact",
    value: function useStateAndSelectorsReact(subStates, selectors) {
      var _this2 = this;

      var _useState = (0, _react.useState)({}),
          _useState2 = _slicedToArray(_useState, 2),
          view = _useState2[0],
          updateView = _useState2[1];

      (0, _react.useEffect)(function () {
        var stopWatches = [];

        _this2.watchSubStatesAndSelectors(subStates, stopWatches, view, updateView);

        _this2.watchSubStatesAndSelectors(selectors, stopWatches, view, updateView);

        return function () {
          return stopWatches.forEach(function (stopWatch) {
            return stopWatch();
          });
        };
      }, []);
    }
  }, {
    key: "watchSubStatesAndSelectors",
    value: function watchSubStatesAndSelectors(subStates, stopWatches, view, updateView) {
      var _this3 = this;

      subStates.forEach(function (subState) {
        if (!('effect' in subState) && !subState.__isSubState__) {
          throw new Error('useState: One of given subStates is not subState');
        }

        stopWatches.push((0, _reactiveJs.watch)(function () {
          return subState;
        }, function () {
          if (!_this3.viewToNeedsUpdateMap.get(view)) {
            setTimeout(function () {
              _this3.viewToNeedsUpdateMap.delete(view);

              updateView({});
            }, 0);
          }

          _this3.viewToNeedsUpdateMap.set(view, true);
        }, {
          deep: true,
          flush: 'sync'
        }));
      });
    }
  }, {
    key: "useStateReact",
    value: function useStateReact(subStates) {
      var _this4 = this;

      var _useState3 = (0, _react.useState)({}),
          _useState4 = _slicedToArray(_useState3, 2),
          view = _useState4[0],
          updateView = _useState4[1];

      (0, _react.useEffect)(function () {
        var stopWatches = [];

        _this4.watchSubStatesAndSelectors(subStates, stopWatches, view, updateView);

        return function () {
          return stopWatches.forEach(function (stopWatch) {
            return stopWatch();
          });
        };
      }, []);
    }
  }, {
    key: "useSelectorsReact",
    value: function useSelectorsReact(selectors) {
      var _this5 = this;

      var _useState5 = (0, _react.useState)({}),
          _useState6 = _slicedToArray(_useState5, 2),
          view = _useState6[0],
          updateView = _useState6[1];

      (0, _react.useEffect)(function () {
        var stopWatches = [];

        _this5.watchSubStatesAndSelectors(selectors, stopWatches, view, updateView);

        return function () {
          return stopWatches.forEach(function (stopWatch) {
            return stopWatch();
          });
        };
      }, []);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useStateAndSelectorsNg",
    value: function useStateAndSelectorsNg(componentInstance, subStateMap, // eslint-disable-next-line @typescript-eslint/no-explicit-any
    selectorMap) {
      this.useStateNg(componentInstance, subStateMap);
      this.useSelectorsNg(componentInstance, selectorMap);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useStateNg",
    value: function useStateNg(componentInstance, subStateMap) {
      var _this6 = this;

      this.stateStopWatches.set(componentInstance, []);
      Object.entries(subStateMap).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            stateName = _ref2[0],
            subState = _ref2[1];

        if (!subState.__isSubState__) {
          throw new Error('useState: One of given subStates is not subState');
        }

        componentInstance[stateName] = subState;

        _this6.stateStopWatches.get(componentInstance).push((0, _reactiveJs.watch)(function () {
          return subState;
        }, function () {
          if (!_this6.componentInstanceToUpdatesMap.get(componentInstance)) {
            setTimeout(function () {
              Object.entries(_this6.componentInstanceToUpdatesMap.get(componentInstance)).forEach( // eslint-disable-next-line @typescript-eslint/no-explicit-any
              function (_ref3) {
                var _ref4 = _slicedToArray(_ref3, 2),
                    key = _ref4[0],
                    value = _ref4[1];

                console.log(key, value);
                componentInstance[key] = value;
              });

              _this6.componentInstanceToUpdatesMap.delete(componentInstance);
            }, 0);
          }

          _this6.componentInstanceToUpdatesMap.set(componentInstance, _objectSpread({}, _this6.componentInstanceToUpdatesMap.get(componentInstance), _defineProperty({}, stateName, subState)));
        }, {
          deep: true,
          flush: 'sync'
        }));
      });
      var originalOnDestroy = componentInstance.ngOnDestroy;

      componentInstance.ngOnDestroy = function () {
        _this6.stateStopWatches.get(componentInstance).forEach(function (stopWatch) {
          return stopWatch();
        });

        _this6.stateStopWatches.delete(componentInstance);

        if (originalOnDestroy) {
          originalOnDestroy();
        }
      };
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useSelectorsNg",
    value: function useSelectorsNg(componentInstance, // eslint-disable-next-line @typescript-eslint/no-explicit-any
    selectorMap) {
      var _this7 = this;

      this.selectorStopWatches.set(componentInstance, []); // eslint-disable-next-line @typescript-eslint/no-explicit-any

      Object.entries(selectorMap).forEach(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 2),
            selectorName = _ref6[0],
            selector = _ref6[1];

        componentInstance[selectorName] = selector.value;

        _this7.selectorStopWatches.get(componentInstance).push((0, _reactiveJs.watch)(function () {
          return selector;
        }, function () {
          if (!_this7.componentInstanceToUpdatesMap.get(componentInstance)) {
            setTimeout(function () {
              Object.entries(_this7.componentInstanceToUpdatesMap.get(componentInstance)).forEach( // eslint-disable-next-line @typescript-eslint/no-explicit-any
              function (_ref7) {
                var _ref8 = _slicedToArray(_ref7, 2),
                    key = _ref8[0],
                    value = _ref8[1];

                console.log(key, value);
                componentInstance[key] = value;
              });

              _this7.componentInstanceToUpdatesMap.delete(componentInstance);
            }, 0);
          }

          _this7.componentInstanceToUpdatesMap.set(componentInstance, _objectSpread({}, _this7.componentInstanceToUpdatesMap.get(componentInstance), _defineProperty({}, selectorName, selector.value)));
        }, {
          deep: true,
          flush: 'sync'
        }));
      });
      var originalOnDestroy = componentInstance.ngOnDestroy;

      componentInstance.ngOnDestroy = function () {
        _this7.selectorStopWatches.get(componentInstance).forEach(function (stopWatch) {
          return stopWatch();
        });

        _this7.stateStopWatches.delete(componentInstance);

        if (originalOnDestroy) {
          originalOnDestroy();
        }
      };
    }
  }, {
    key: "useStateSvelte",
    value: function useStateSvelte(id, subStates) {
      var _this8 = this;

      this.stateStopWatches.set(id, []);
      this.stateWritables.set(id, []);
      subStates.forEach(function (subState, index) {
        _this8.stateWritables.get(id).push((0, _store.writable)(subState));

        _this8.stateStopWatches.get(id).push((0, _reactiveJs.watch)(function () {
          return subState;
        }, function () {
          if (!_this8.idToUpdatesMap.get(id)) {
            setTimeout(function () {
              Object.entries(_this8.idToUpdatesMap.get(id)).forEach( // eslint-disable-next-line @typescript-eslint/no-explicit-any
              function (_ref9) {
                var _ref10 = _slicedToArray(_ref9, 2),
                    key = _ref10[0],
                    value = _ref10[1];

                if (key.startsWith('state')) {
                  _this8.stateWritables.get(id)[parseInt(key.slice(5))].set(value);
                } else {
                  _this8.selectorWritables.get(id)[parseInt(key.slice(8))].set(value);
                }
              });

              _this8.idToUpdatesMap.delete(id);
            }, 0);
          }

          _this8.idToUpdatesMap.set(id, _objectSpread({}, _this8.idToUpdatesMap.get(id), _defineProperty({}, "state".concat(index), subState)));
        }, {
          deep: true,
          flush: 'sync'
        }));
      });
      (0, _svelte.onDestroy)(function () {
        return _this8.stateStopWatches.get(id).forEach(function (stopWatch) {
          return stopWatch();
        });
      });
      return this.stateWritables.get(id);
    } // eslint-disable-next-line @typescript-eslint/no-explicit-any

  }, {
    key: "useSelectorsSvelte",
    value: function useSelectorsSvelte(id, selectors) {
      var _this9 = this;

      this.selectorStopWatches.set(id, []);
      this.selectorWritables.set(id, []); // eslint-disable-next-line @typescript-eslint/no-explicit-any

      selectors.forEach(function (selector, index) {
        _this9.selectorWritables.get(id).push((0, _store.writable)(selector.value));

        _this9.selectorStopWatches.get(id).push((0, _reactiveJs.watch)(function () {
          return selector;
        }, function () {
          if (!_this9.idToUpdatesMap.get(id)) {
            setTimeout(function () {
              Object.entries(_this9.idToUpdatesMap.get(id)).forEach( // eslint-disable-next-line @typescript-eslint/no-explicit-any
              function (_ref11) {
                var _ref12 = _slicedToArray(_ref11, 2),
                    key = _ref12[0],
                    value = _ref12[1];

                if (key.startsWith('state')) {
                  _this9.stateWritables.get(id)[parseInt(key.slice(5))].set(value);
                } else {
                  _this9.selectorWritables.get(id)[parseInt(key.slice(8))].set(value);
                }
              });

              _this9.idToUpdatesMap.delete(id);
            }, 0);
          }

          _this9.idToUpdatesMap.set(id, _objectSpread({}, _this9.idToUpdatesMap.get(id), _defineProperty({}, "selector".concat(index), selector.value)));
        }, {
          deep: true,
          flush: 'sync'
        }));
      });
      (0, _svelte.onDestroy)(function () {
        return _this9.selectorStopWatches.get(id).forEach(function (stopWatch) {
          return stopWatch();
        });
      });
      return this.selectorWritables.get(id);
    }
  }]);

  return Store;
}();

exports.default = Store;
//# sourceMappingURL=Store.js.map